from os import popen
import xmlrpclib
import re

from configFile import KBlackBoardConfig

def getBcastAddresses():
	p = popen("/sbin/ifconfig 2>/dev/null" , 'r')
	
	result = []
	
	for line in p:
		if "Bcast:" in line:
			result.append(re.findall("Bcast:([0-9.]*) " , line )[0])
	
	p.close()
	
	return set(result)

def findAlive( addresses ):
	
	result = []
	
	for address in addresses :
		p = popen("ping -b %s -w 1 2>/dev/null" % address , 'r')
		
		for line in p:
			if "bytes from" in line:
				result.append(re.findall("bytes from ([0-9.]*): " , line)[0])
		
		p.close()
		
	
	return list(set(result))
		
def findAliveComputers():
	return findAlive(getBcastAddresses())

def checkServer( host ):
	
	import traceback
	
	info = False
		
	try :
		port = KBlackBoardConfig.getint('Common','Port')
	
		s = xmlrpclib.Server("http://%s:%d" % ( host , port ))
		info = s.rpcServerInfo()
	except :
		pass
	
	return info
		
def findServers( addresses ):
	
	import threading
	
	result = []
	
	for address in addresses:
		
		info = checkServer( address )
		if info :
			result.append((address,info))
	
	return list(set(result))
