# -*- coding: utf-8 -*-



from qt import *
from configFile import KBlackBoardConfig

class frmConnect(QDialog):
	def __init__(self,parent = None,name = None,modal = 0,fl = 0):
		QDialog.__init__(self,parent,name,modal,fl)

		if not name:
			self.setName("frmConnect")

		self.setSizePolicy(QSizePolicy(5,5,0,0,self.sizePolicy().hasHeightForWidth()))
		self.setMinimumSize(QSize(650,130))
		self.setMaximumSize(QSize(650,130))
		self.setSizeGripEnabled(0)
		
		
		LayoutWidget = QWidget(self,"layout16")
		LayoutWidget.setGeometry(QRect(10,10,630,110))
		layout16 = QHBoxLayout(LayoutWidget,11,6,"layout16")
		
		layout15 = QVBoxLayout(None,0,6,"layout15")
		
		layout13 = QGridLayout(None,1,1,0,6,"layout13")
		
		self.textLabel2 = QLabel(LayoutWidget,"textLabel2")
		
		layout13.addWidget(self.textLabel2,0,0)
		
		self.textLabel3 = QLabel(LayoutWidget,"textLabel3")
		
		layout13.addWidget(self.textLabel3,1,0)
		spacer5 = QSpacerItem(71,21,QSizePolicy.Minimum,QSizePolicy.Minimum)
		layout13.addMultiCell(spacer5,2,2,0,1)
		
		self.txtName = QLineEdit(LayoutWidget,"txtName")
		
		layout13.addMultiCellWidget(self.txtName,0,0,1,2)
		
		self.cmbServer = QComboBox(0,LayoutWidget,"cmbServer")
		self.cmbServer.setSizePolicy(QSizePolicy(7,0,0,0,self.cmbServer.sizePolicy().hasHeightForWidth()))
		self.cmbServer.setEditable(1)
		
		layout13.addMultiCellWidget(self.cmbServer,1,1,1,2)
		
		self.chkConnectOnStart = QCheckBox(LayoutWidget,"chkConnectOnStart")
		self.chkConnectOnStart.setSizePolicy(QSizePolicy(3,0,0,0,self.chkConnectOnStart.sizePolicy().hasHeightForWidth()))
		
		layout13.addWidget(self.chkConnectOnStart,2,2)
		layout15.addLayout(layout13)
		spacer6 = QSpacerItem(21,31,QSizePolicy.Minimum,QSizePolicy.Expanding)
		layout15.addItem(spacer6)
		layout16.addLayout(layout15)
		spacer4 = QSpacerItem(40,21,QSizePolicy.Fixed,QSizePolicy.Minimum)
		layout16.addItem(spacer4)
		
		layout10 = QVBoxLayout(None,0,6,"layout10")
		
		self.btnConnect = QPushButton(LayoutWidget,"btnConnect")
		layout10.addWidget(self.btnConnect)
		
		self.btnExit = QPushButton(LayoutWidget,"btnExit")
		layout10.addWidget(self.btnExit)
		spacer3 = QSpacerItem(20,20,QSizePolicy.Minimum,QSizePolicy.Expanding)
		layout10.addItem(spacer3)
		layout16.addLayout(layout10)
		
		self.languageChange()
		
		self.resize(QSize(650,130).expandedTo(self.minimumSizeHint()))
		self.clearWState(Qt.WState_Polished)
		
		self.connect(self.btnExit,SIGNAL("clicked()"),self.reject)
		self.connect(self.btnConnect,SIGNAL("clicked()"),self.accept)
		
		self.textLabel2.setBuddy(self.txtName)
		
		self.readConfig()

	def readConfig(self):
		
		from findserver import findAliveComputers, findServers
		from socket import gethostbyaddr
		
		self.chkConnectOnStart.setChecked(KBlackBoardConfig.getboolean('Client','ConnectOnStart'))
		self.txtName.setText(KBlackBoardConfig.get('Client','Name'))
		
		prevserver = KBlackBoardConfig.get('Client','Server')
		addresses = findAliveComputers()
		if len( addresses ) > 20 :
			print "Refusing automatic server lookup, too big subnet"
			addresses = [] #This way it will still check the last server used
		addresses.append(prevserver)
		
		servers = findServers(addresses)
		
		for host , info in servers:
			try :
				name = gethostbyaddr( host )[0]
			except:
				name = host
			
			desc = "%s    %s" % (name, info)
			
			self.cmbServer.insertItem(desc)
			
			if host == prevserver : self.cmbServer.setEditText( desc )
		
	
	def writeConfig(self):
		KBlackBoardConfig.set('Client','ConnectOnStart',self.chkConnectOnStart.isChecked())
		KBlackBoardConfig.set('Client','Name',str(self.txtName.text()))
		KBlackBoardConfig.set('Client','Server',str(self.cmbServer.currentText()).split(' ')[0])
	
	def languageChange(self):
		self.setCaption(self.__tr("Connect to server"))
		self.textLabel2.setText(self.__tr("Name:"))
		self.textLabel3.setText(self.__tr("Server:"))
		self.chkConnectOnStart.setText(self.__tr("Connect automatically on start"))
		self.btnConnect.setText(self.__tr("Connect"))
		self.btnExit.setText(self.__tr("Exit"))


	def __tr(self,s,c = None):
		return qApp.translate("frmConnect",s,c)
