from qt import *
import sys, thread, os, xmlrpclib

from frmMain import frmMain
from frmConnect import frmConnect
from configFile import KBlackBoardConfig
from findserver import checkServer
from rpc import rpcServer


if __name__ == "__main__":
	
	app = QApplication(sys.argv)
	
	server = None
	
	if KBlackBoardConfig.getboolean('Client','ConnectOnStart'):
		server = KBlackBoardConfig.get('Client','Server')
	
	while True :
		if len(KBlackBoardConfig.get('Client','Name'))>0 and checkServer(server) :
			break
		
		connectWindow = frmConnect()
		
		if not connectWindow.exec_loop() :
			raise SystemExit
		
		connectWindow.writeConfig()
		
		server = KBlackBoardConfig.get('Client','Server')
	
	KBlackBoardConfig.write()
	
	mainWindow = frmMain()
	
	callback = rpcServer( mainWindow.fileslist )
	
	server = xmlrpclib.Server( 
		"http://%s:%d" % ( KBlackBoardConfig.get('Client','Server'),
				KBlackBoardConfig.getint('Common','Port') ),
		allow_none = True )
	
	
	callback.clientID = server.rpcRegisterClient( KBlackBoardConfig.get('Client','Name'),
		KBlackBoardConfig.getint('Client','CallbackPort') )
	
	callback.start()
	
	mainWindow.show()
	app.setMainWidget(mainWindow)
	
# 	server = rpc.rpcServer( "localhost" , 8001 , mainWindow )
# 	server.start()
# 	
	app.exec_loop() # When gui exits, stop the server too
	
	callback.stop()
	
	KBlackBoardConfig.write()
	
	
	
