
from qt import *

from configFile import KBlackBoardConfig


class clientsPopup( QPopupMenu ):
	
	'''Handles popup for lstClients and also the related actions'''
	
	def __init__( self , parent , clientslist , name = None ):
		QPopupMenu.__init__( self , parent , name )
		self.parent = parent
		self.clientslist = clientslist
		
		self.insertItem( self.__tr("Send file to selected client(s)") ,  self.sendToSelected , 0 , 1 )
		self.insertItem( self.__tr("Send file to all clients") , self.sendToAll , 0 , 2 )
		
		self.insertSeparator( 3 )
		
		self.insertItem( self.__tr("Remove from server") , self.remove , 0 , 3 )
		
		self.insertSeparator( 4 )
		
		self.insertItem( self.__tr("Open chat with selected client(s)") , 5 )

		self.itemSpecific = [ 1, 3, 5 ] # Enable these only when item is selected
	
	def popup( self , item , point ) :
		
		if item :
			gotItem = True
		else :
			gotItem = False
		
		for idx in self.itemSpecific :
			self.setItemEnabled( idx , gotItem )

		QPopupMenu.popup( self , point )
	
	def sendToSelected( self ):
		for idx in range( self.parent.count() ):
			if self.parent.isSelected( idx ):
				c = self.clientslist.getClient( idx )
				c.sendFile()
	
	def sendToAll( self ):
		for c in self.clientslist.clients :
			c.sendFile()
	
	def remove( self ):
		
		idx = self.parent.currentItem()
		c = self.clientslist.getClient( idx )
		
		reason, ok = QInputDialog.getText(
			"KBlackBoard",
			str(self.__tr("Reason to remove %s from server?:")) % c.name)
			
		
		reason = str(self.__tr("You were removed from server, reason: %s")) % reason
		
		self.clientslist.remove( c, reason )
	
	
	
	def __tr(self,s,c = None):
		return qApp.translate("frmMain",s,c)
		