# -*- coding: utf-8 -*-

from qt import *
from filesPopup import filesPopup
from filesList import filesList
from clientsPopup import clientsPopup
from clientsList import clientsList
from configFile import KBlackBoardConfig


class frmMain(QMainWindow):
	def __init__(self,parent = None,name = None,fl = 0):
		QMainWindow.__init__(self,parent,name,fl)
		self.statusBar()
		
		if not name:
			self.setName("frmMain")
		
		self.splitter8 = QSplitter(self,"splitter8")
		self.splitter8.setOrientation(QSplitter.Horizontal)
		
		self.setCentralWidget(self.splitter8)
		
		
		LayoutWidget = QWidget(self.splitter8,"layout22")
		layout22 = QVBoxLayout(LayoutWidget,11,6,"layout22")
		
		self.textLabel1 = QLabel(LayoutWidget,"textLabel1")
		layout22.addWidget(self.textLabel1)
		
		#######################################
		# lstFiles and related signals & objects
		
		self.lstFiles = QListBox(LayoutWidget,"lstFiles")
		self.lstFiles.setMinimumSize(QSize(100,100))
		layout22.addWidget(self.lstFiles)
		
		self.fileslist = filesList( self.lstFiles )
		self.lstFilesPopup = filesPopup( self.lstFiles , self.fileslist)
		self.connect( self.lstFiles , SIGNAL("contextMenuRequested ( QListBoxItem * , const QPoint & )") , self.lstFilesPopup.popup )
		
		if len( KBlackBoardConfig.get('Server','List') ) > 0 :
			self.fileslist.loadList( KBlackBoardConfig.get('Server','List') )
		
		layout15 = QHBoxLayout(None,0,6,"layout15")
		
		self.btnNew = QPushButton(LayoutWidget,"btnNew")
		layout15.addWidget(self.btnNew)
		self.connect( self.btnNew , SIGNAL("clicked()") , self.lstFilesPopup.new )
		
		self.btnEdit = QPushButton(LayoutWidget,"btnEdit")
		layout15.addWidget(self.btnEdit)
		self.connect( self.btnEdit , SIGNAL("clicked()") , self.lstFilesPopup.edit )
		layout22.addLayout(layout15)
		
		LayoutWidget_2 = QWidget(self.splitter8,"layout23")
		layout23 = QVBoxLayout(LayoutWidget_2,11,6,"layout23")
		
		self.textLabel2 = QLabel(LayoutWidget_2,"textLabel2")
		layout23.addWidget(self.textLabel2)
		
		#####################################
		# lstClients and related signals & objects
		
		
		self.lstClients = QListBox(LayoutWidget_2,"lstClients")
		self.lstClients.setMinimumSize(QSize(100,100))
		self.lstClients.setSelectionMode(QListBox.Extended)
		layout23.addWidget(self.lstClients)
		
		self.clientslist = clientsList( self.lstClients, self.fileslist )
		self.lstClientsPopup = clientsPopup( self.lstClients, self.clientslist )
		self.connect( self.lstClients , SIGNAL("contextMenuRequested ( QListBoxItem * , const QPoint & )") , self.lstClientsPopup.popup )
		
		layout13 = QHBoxLayout(None,0,6,"layout13")
		
		self.btnSend = QPushButton(LayoutWidget_2,"btnSend")
		layout13.addWidget(self.btnSend)
		self.connect( self.btnSend , SIGNAL("clicked()") , self.lstClientsPopup.sendToAll )

		
		self.btnChat = QPushButton(LayoutWidget_2,"btnChat")
		layout13.addWidget(self.btnChat)
		layout23.addLayout(layout13)
		
		self.languageChange()
		
		self.resize(QSize(780,550).expandedTo(self.minimumSizeHint()))
		self.clearWState(Qt.WState_Polished)
	
# 	def lstFilesSelectionChanged( self ):
# 		if self.lstFiles.currentItem() == -1 :
# 			self.btnEdit.
	

	def languageChange(self):
		self.setCaption(self.__tr("KBlackBoard"))
		self.textLabel1.setText(self.__tr("Files:"))
		self.btnNew.setText(self.__tr("New"))
		QToolTip.add(self.btnNew,self.__tr("Create or load new file"))
		self.btnEdit.setText(self.__tr("Edit"))
		QToolTip.add(self.btnEdit,self.__tr("Edit selected file"))
		self.textLabel2.setText(self.__tr("Clients:"))
		self.btnSend.setText(self.__tr("Send file to all"))
		QToolTip.add(self.btnSend,self.__tr("Send selected file to all clients"))
		self.btnChat.setText(self.__tr("Open chat"))
		QToolTip.add(self.btnChat,self.__tr("Open chat with selected client(s)"))
	

	def __tr(self,s,c = None):
		return qApp.translate("frmMain",s,c)
