# -*- coding: utf-8 -*-

from qt import *
import os

from configFile import KBlackBoardConfig

class frmServer(QDialog):
	def __init__(self,parent = None,name = None,modal = 0,fl = 0):
		QDialog.__init__(self,parent,name,modal,fl)
		
		if not name:
			self.setName("frmServer")
	
		self.setMinimumSize(QSize(650,90))
		self.setMaximumSize(QSize(650,90))
		
		
		LayoutWidget = QWidget(self,"layout22")
		LayoutWidget.setGeometry(QRect(0,0,650,90))
		layout22 = QHBoxLayout(LayoutWidget,11,6,"layout22")
		
		layout21 = QVBoxLayout(None,0,6,"layout21")
		
		layout18 = QHBoxLayout(None,0,6,"layout18")
		
		self.textLabel4 = QLabel(LayoutWidget,"textLabel4")
		layout18.addWidget(self.textLabel4)
		
		self.txtInfo = QLineEdit(LayoutWidget,"txtInfo")
		layout18.addWidget(self.txtInfo)
		layout21.addLayout(layout18)
		
		layout17 = QHBoxLayout(None,0,6,"layout17")
		
		self.textLabel5 = QLabel(LayoutWidget,"textLabel5")
		layout17.addWidget(self.textLabel5)
		
		self.txtList = QLineEdit(LayoutWidget,"txtList")
		layout17.addWidget(self.txtList)
		
		self.btnList = QPushButton(LayoutWidget,"btnList")
		layout17.addWidget(self.btnList)
		layout21.addLayout(layout17)
		layout22.addLayout(layout21)
		spacer7 = QSpacerItem(40,20,QSizePolicy.Fixed,QSizePolicy.Minimum)
		layout22.addItem(spacer7)
		
		self.connect( self.btnList , SIGNAL('clicked()') , self.__selectFile )
		
		layout19 = QVBoxLayout(None,0,6,"layout19")
		
		self.btnStart = QPushButton(LayoutWidget,"btnStart")
		layout19.addWidget(self.btnStart)
		
		self.btnExit = QPushButton(LayoutWidget,"btnExit")
		layout19.addWidget(self.btnExit)
		layout22.addLayout(layout19)
		
		self.languageChange()
		
		self.resize(QSize(650,90).expandedTo(self.minimumSizeHint()))
		self.clearWState(Qt.WState_Polished)
		
		self.connect(self.btnStart,SIGNAL("clicked()"),self.accept)
		self.connect(self.btnExit,SIGNAL("clicked()"),self.reject)
		
		self.readConfig()
	
	def __selectFile(self):
		f = QFileDialog.getOpenFileName(
			os.path.expanduser('~'),
			"KBlackBoard List files (*.kbb)",
			self, None, self.__tr("Select list to open") )
		
		self.txtList.setText( f )
	
	def readConfig(self):
		self.txtInfo.setText( KBlackBoardConfig.get('Server','Description') )
		self.txtList.setText( KBlackBoardConfig.get('Server','List') )
	
	def saveConfig(self):
		KBlackBoardConfig.set('Server','Description',str(self.txtInfo.text()))
		KBlackBoardConfig.set('Server','List',str(self.txtList.text()))
	
	def languageChange(self):
		self.setCaption(self.__tr("Start server"))
		self.textLabel4.setText(self.__tr("Description:"))
		self.textLabel5.setText(self.__tr("Preload list:"))
		self.btnList.setText(self.__tr("..."))
		self.btnStart.setText(self.__tr("Start"))
		self.btnExit.setText(self.__tr("Exit"))


	def __tr(self,s,c = None):
		return qApp.translate("frmServer",s,c)
